Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4328)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4329)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Renamed wall_flags_0 to wall_flags_static_0
+! 
+! 4328 2019-12-09 18:53:04Z suehring
 ! Minor formatting adjustments
 ! 
@@ -186,5 +189,5 @@
                nzb_max,                                                        &
                nzt,                                                            &
-               wall_flags_0
+               wall_flags_static_0
 
     USE grid_variables,                                                        &
@@ -408,5 +411,5 @@
 !--             u component - x-direction
 !--             WS1 (0), WS3 (1), WS5 (2)
-                IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),1)  .OR.                &
+                IF ( .NOT. BTEST(wall_flags_static_0(k,j,i+1),1)  .OR.         &
                          ( ( bc_dirichlet_l .OR. bc_radiation_l )              &
                            .AND. i <= nxlu  )    .OR.                          &
@@ -415,7 +418,7 @@
                 THEN                                                           
                     advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 0 )      
-                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),1)  .AND.         &
-                                 BTEST(wall_flags_0(k,j,i+1),1)  .OR.          &
-                           .NOT. BTEST(wall_flags_0(k,j,i-1),1) )              &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i+2),1)  .AND.  &
+                                 BTEST(wall_flags_static_0(k,j,i+1),1)  .OR.   &
+                           .NOT. BTEST(wall_flags_static_0(k,j,i-1),1) )       &
                                                      .OR.                      &
                          ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
@@ -428,7 +431,7 @@
 !--                Clear flag for WS1                                          
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 0 )       
-                ELSEIF ( BTEST(wall_flags_0(k,j,i+1),1)  .AND.                 &
-                         BTEST(wall_flags_0(k,j,i+2),1)  .AND.                 &
-                         BTEST(wall_flags_0(k,j,i-1),1) )                      &
+                ELSEIF ( BTEST(wall_flags_static_0(k,j,i+1),1)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j,i+2),1)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j,i-1),1) )               &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 2 )       
@@ -440,5 +443,5 @@
 !--             u component - y-direction                                      
 !--             WS1 (3), WS3 (4), WS5 (5)                                      
-                IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),1)   .OR.               &
+                IF ( .NOT. BTEST(wall_flags_static_0(k,j+1,i),1)   .OR.        &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
                            .AND. j == nys   )    .OR.                          &
@@ -447,7 +450,7 @@
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 3 )       
-                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),1)  .AND.         &
-                                 BTEST(wall_flags_0(k,j+1,i),1)  .OR.          &
-                           .NOT. BTEST(wall_flags_0(k,j-1,i),1) )              &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j+2,i),1)  .AND.  &
+                                 BTEST(wall_flags_static_0(k,j+1,i),1)  .OR.   &
+                           .NOT. BTEST(wall_flags_static_0(k,j-1,i),1) )       &
                                                      .OR.                      &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
@@ -460,7 +463,7 @@
 !--                Clear flag for WS1                                          
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 3 )       
-                ELSEIF ( BTEST(wall_flags_0(k,j+1,i),1)  .AND.                 &
-                         BTEST(wall_flags_0(k,j+2,i),1)  .AND.                 &
-                         BTEST(wall_flags_0(k,j-1,i),1) )                      &
+                ELSEIF ( BTEST(wall_flags_static_0(k,j+1,i),1)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j+2,i),1)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j-1,i),1) )               &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 5 )       
@@ -490,32 +493,32 @@
                                                                                
                 flag_set = .FALSE.                                             
-                IF ( ( .NOT. BTEST(wall_flags_0(k-1,j,i),1)   .AND.            &
-                             BTEST(wall_flags_0(k,j,i),1)     .AND.            &
-                             BTEST(wall_flags_0(k+1,j,i),1) ) .OR.             &
-                     ( .NOT. BTEST(wall_flags_0(k_pp,j,i),1)  .AND.            &                              
-                             BTEST(wall_flags_0(k+1,j,i),1)   .AND.            &
-                             BTEST(wall_flags_0(k,j,i),1) )   .OR.             &
-                     k == nzt )                                                &
+                IF ( ( .NOT. BTEST(wall_flags_static_0(k-1,j,i),1)       .AND.     &
+                             BTEST(wall_flags_static_0(k,j,i),1)         .AND.     &
+                             BTEST(wall_flags_static_0(k+1,j,i),1) )     .OR.      &
+                     ( .NOT. BTEST(wall_flags_static_0(k_pp,j,i),1)      .AND.     &                              
+                             BTEST(wall_flags_static_0(k+1,j,i),1)       .AND.     &
+                             BTEST(wall_flags_static_0(k,j,i),1) )       .OR.      &
+                     k == nzt )                                                    &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 6 )       
                    flag_set = .TRUE.                                           
-                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),1)    .OR.       &
-                           .NOT. BTEST(wall_flags_0(k_ppp,j,i),1) ) .AND.      & 
-                                 BTEST(wall_flags_0(k-1,j,i),1)     .AND.      &
-                                 BTEST(wall_flags_0(k,j,i),1)       .AND.      &
-                                 BTEST(wall_flags_0(k+1,j,i),1)     .AND.      &
-                                 BTEST(wall_flags_0(k_pp,j,i),1)    .AND.      &
-                           .NOT. flag_set                           .OR.       & 
-                         k == nzt - 1 )                                        &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k_mm,j,i),1)    .OR.    &
+                           .NOT. BTEST(wall_flags_static_0(k_ppp,j,i),1) ) .AND.   & 
+                                 BTEST(wall_flags_static_0(k-1,j,i),1)     .AND.   &
+                                 BTEST(wall_flags_static_0(k,j,i),1)       .AND.   &
+                                 BTEST(wall_flags_static_0(k+1,j,i),1)     .AND.   &
+                                 BTEST(wall_flags_static_0(k_pp,j,i),1)    .AND.   &
+                           .NOT. flag_set                           .OR.           & 
+                         k == nzt - 1 )                                            &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 7 )       
                    flag_set = .TRUE.                                           
-                ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),1)  .AND.                &
-                         BTEST(wall_flags_0(k-1,j,i),1)   .AND.                &
-                         BTEST(wall_flags_0(k,j,i),1)     .AND.                &
-                         BTEST(wall_flags_0(k+1,j,i),1)   .AND.                &
-                         BTEST(wall_flags_0(k_pp,j,i),1)  .AND.                &
-                         BTEST(wall_flags_0(k_ppp,j,i),1) .AND.                &
-                         .NOT. flag_set )                                      &
+                ELSEIF ( BTEST(wall_flags_static_0(k_mm,j,i),1)            .AND.   &
+                         BTEST(wall_flags_static_0(k-1,j,i),1)             .AND.   &
+                         BTEST(wall_flags_static_0(k,j,i),1)               .AND.   &
+                         BTEST(wall_flags_static_0(k+1,j,i),1)             .AND.   &
+                         BTEST(wall_flags_static_0(k_pp,j,i),1)            .AND.   &
+                         BTEST(wall_flags_static_0(k_ppp,j,i),1)           .AND.   &
+                         .NOT. flag_set )                                          &
                 THEN
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 8 )
@@ -539,5 +542,5 @@
 !--             v component - x-direction
 !--             WS1 (9), WS3 (10), WS5 (11)
-                IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),2)  .OR.                &
+                IF ( .NOT. BTEST(wall_flags_static_0(k,j,i+1),2)  .OR.         &
                          ( ( bc_dirichlet_l .OR. bc_radiation_l )              &
                            .AND. i == nxl   )    .OR.                          &
@@ -548,7 +551,7 @@
 !                                                                              
 !--             WS3                                                            
-                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),2)   .AND.        &
-                                 BTEST(wall_flags_0(k,j,i+1),2) ) .OR.         &
-                           .NOT. BTEST(wall_flags_0(k,j,i-1),2)                &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i+2),2)   .AND. &
+                                 BTEST(wall_flags_static_0(k,j,i+1),2) ) .OR.  &
+                           .NOT. BTEST(wall_flags_static_0(k,j,i-1),2)         &
                                                  .OR.                          &
                          ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
@@ -560,8 +563,8 @@
 !                                                                              
 !--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 9 )       
-                ELSEIF ( BTEST(wall_flags_0(k,j,i+1),2)  .AND.                 &
-                         BTEST(wall_flags_0(k,j,i+2),2)  .AND.                 &
-                         BTEST(wall_flags_0(k,j,i-1),2) )                      &
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 9 )     
+                ELSEIF ( BTEST(wall_flags_static_0(k,j,i+1),2)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j,i+2),2)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j,i-1),2) )               &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 11 )      
@@ -573,5 +576,5 @@
 !--             v component - y-direction                                      
 !--             WS1 (12), WS3 (13), WS5 (14)                                   
-                IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),2) .OR.                 &
+                IF ( .NOT. BTEST(wall_flags_static_0(k,j+1,i),2) .OR.          &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
                            .AND. j <= nysv  )    .OR.                          &
@@ -580,7 +583,7 @@
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 12 )      
-                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),2)  .AND.         &
-                                 BTEST(wall_flags_0(k,j+1,i),2)  .OR.          &
-                           .NOT. BTEST(wall_flags_0(k,j-1,i),2) )              &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j+2,i),2)  .AND.  &
+                                 BTEST(wall_flags_static_0(k,j+1,i),2)  .OR.   &
+                           .NOT. BTEST(wall_flags_static_0(k,j-1,i),2) )       &
                                                      .OR.                      &
                          ( (  bc_dirichlet_s .OR. bc_radiation_s )             &
@@ -593,7 +596,7 @@
 !--                Clear flag for WS1                                          
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 12 )      
-                ELSEIF ( BTEST(wall_flags_0(k,j+1,i),2)  .AND.                 &
-                         BTEST(wall_flags_0(k,j+2,i),2)  .AND.                 &
-                         BTEST(wall_flags_0(k,j-1,i),2) )                      & 
+                ELSEIF ( BTEST(wall_flags_static_0(k,j+1,i),2)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j+2,i),2)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j-1,i),2) )               & 
                 THEN
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 14 )
@@ -623,32 +626,32 @@
                 
                 flag_set = .FALSE.
-                IF ( ( .NOT. BTEST(wall_flags_0(k-1,j,i),2)   .AND.            &
-                             BTEST(wall_flags_0(k,j,i),2)     .AND.            &
-                             BTEST(wall_flags_0(k+1,j,i),2) ) .OR.             &
-                     ( .NOT. BTEST(wall_flags_0(k_pp,j,i),2)  .AND.            &                              
-                             BTEST(wall_flags_0(k+1,j,i),2)   .AND.            &
-                             BTEST(wall_flags_0(k,j,i),2) )   .OR.             &
-                     k == nzt )                                                &
+                IF ( ( .NOT. BTEST(wall_flags_static_0(k-1,j,i),2)          .AND.     &
+                             BTEST(wall_flags_static_0(k,j,i),2)            .AND.     &
+                             BTEST(wall_flags_static_0(k+1,j,i),2) )        .OR.      &
+                     ( .NOT. BTEST(wall_flags_static_0(k_pp,j,i),2)         .AND.     &                              
+                             BTEST(wall_flags_static_0(k+1,j,i),2)          .AND.     &
+                             BTEST(wall_flags_static_0(k,j,i),2) )          .OR.      &
+                     k == nzt )                                                       &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 15 )      
                    flag_set = .TRUE.                                           
-                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),2)    .OR.       &
-                           .NOT. BTEST(wall_flags_0(k_ppp,j,i),2) ) .AND.      & 
-                                 BTEST(wall_flags_0(k-1,j,i),2)     .AND.      &
-                                 BTEST(wall_flags_0(k,j,i),2)       .AND.      &
-                                 BTEST(wall_flags_0(k+1,j,i),2)     .AND.      &
-                                 BTEST(wall_flags_0(k_pp,j,i),2)    .AND.      &
-                           .NOT. flag_set                           .OR.       & 
-                         k == nzt - 1 )                                        &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k_mm,j,i),2)    .OR.       &
+                           .NOT. BTEST(wall_flags_static_0(k_ppp,j,i),2) ) .AND.      & 
+                                 BTEST(wall_flags_static_0(k-1,j,i),2)     .AND.      &
+                                 BTEST(wall_flags_static_0(k,j,i),2)       .AND.      &
+                                 BTEST(wall_flags_static_0(k+1,j,i),2)     .AND.      &
+                                 BTEST(wall_flags_static_0(k_pp,j,i),2)    .AND.      &
+                           .NOT. flag_set                                  .OR.       & 
+                         k == nzt - 1 )                                               &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 16 )      
                    flag_set = .TRUE.                                           
-                ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),2)  .AND.                &
-                         BTEST(wall_flags_0(k-1,j,i),2)   .AND.                &
-                         BTEST(wall_flags_0(k,j,i),2)     .AND.                &
-                         BTEST(wall_flags_0(k+1,j,i),2)   .AND.                &
-                         BTEST(wall_flags_0(k_pp,j,i),2)  .AND.                &
-                         BTEST(wall_flags_0(k_ppp,j,i),2) .AND.                &
-                         .NOT. flag_set )                                      &
+                ELSEIF ( BTEST(wall_flags_static_0(k_mm,j,i),2)             .AND.     &
+                         BTEST(wall_flags_static_0(k-1,j,i),2)              .AND.     &
+                         BTEST(wall_flags_static_0(k,j,i),2)                .AND.     &
+                         BTEST(wall_flags_static_0(k+1,j,i),2)              .AND.     &
+                         BTEST(wall_flags_static_0(k_pp,j,i),2)             .AND.     &
+                         BTEST(wall_flags_static_0(k_ppp,j,i),2)            .AND.     &
+                         .NOT. flag_set )                                             &
                 THEN
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 17 )
@@ -672,5 +675,5 @@
 !--             w component - x-direction
 !--             WS1 (18), WS3 (19), WS5 (20)
-                IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),3) .OR.                 &
+                IF ( .NOT. BTEST(wall_flags_static_0(k,j,i+1),3) .OR.          &
                          ( (  bc_dirichlet_l .OR. bc_radiation_l )             &
                            .AND. i == nxl   )    .OR.                          &
@@ -678,8 +681,8 @@
                            .AND. i == nxr   ) )                                &
                 THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 18 )      
-                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),3)  .AND.         &
-                                 BTEST(wall_flags_0(k,j,i+1),3)  .OR.          &
-                           .NOT. BTEST(wall_flags_0(k,j,i-1),3) )              &
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 18 )     
+                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i+2),3)  .AND.  &
+                                 BTEST(wall_flags_static_0(k,j,i+1),3)  .OR.   &
+                           .NOT. BTEST(wall_flags_static_0(k,j,i-1),3) )       &
                                                      .OR.                      &
                          ( ( bc_dirichlet_r .OR. bc_radiation_r )              &
@@ -692,7 +695,7 @@
 !--                Clear flag for WS1                                          
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 18 )      
-                ELSEIF ( BTEST(wall_flags_0(k,j,i+1),3)  .AND.                 &
-                         BTEST(wall_flags_0(k,j,i+2),3)  .AND.                 &
-                         BTEST(wall_flags_0(k,j,i-1),3) )                      &
+                ELSEIF ( BTEST(wall_flags_static_0(k,j,i+1),3)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j,i+2),3)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j,i-1),3) )               &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i),20 )       
@@ -704,5 +707,5 @@
 !--             w component - y-direction                                      
 !--             WS1 (21), WS3 (22), WS5 (23)                                   
-                IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),3) .OR.                 &
+                IF ( .NOT. BTEST(wall_flags_static_0(k,j+1,i),3) .OR.          &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
                            .AND. j == nys   )    .OR.                          &
@@ -710,9 +713,9 @@
                            .AND. j == nyn   ) )                                &
                 THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 21 )      
-                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),3)  .AND.         &
-                                 BTEST(wall_flags_0(k,j+1,i),3)  .OR.          &
-                           .NOT. BTEST(wall_flags_0(k,j-1,i),3) )              &
-                                                     .OR.                      &
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 21 )     
+                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j+2,i),3)  .AND.  &
+                                 BTEST(wall_flags_static_0(k,j+1,i),3)  .OR.   &
+                           .NOT. BTEST(wall_flags_static_0(k,j-1,i),3) )       &
+                                                     .OR.                     
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
                            .AND. j == nysv  )    .OR.                          &
@@ -724,8 +727,8 @@
 !--                Clear flag for WS1                                          
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 21 )      
-                ELSEIF ( BTEST(wall_flags_0(k,j+1,i),3)  .AND.                 &
-                         BTEST(wall_flags_0(k,j+2,i),3)  .AND.                 &
-                         BTEST(wall_flags_0(k,j-1,i),3) )                      &
-                THEN
+                ELSEIF ( BTEST(wall_flags_static_0(k,j+1,i),3)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j+2,i),3)  .AND.          &
+                         BTEST(wall_flags_static_0(k,j-1,i),3) )               &
+                THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 23 )
 !
@@ -754,10 +757,10 @@
                 ENDIF  
                 
-                flag_set = .FALSE.
-                IF ( ( .NOT. BTEST(wall_flags_0(k,j,i),3)     .AND.            &
-                             BTEST(wall_flags_0(k+1,j,i),3) ) .OR.             &
-                     ( .NOT. BTEST(wall_flags_0(k+1,j,i),3)   .AND.            &
-                             BTEST(wall_flags_0(k,j,i),3) )   .OR.             &        
-                     k == nzt -1 )                                             &
+                flag_set = .FALSE.                                        
+                IF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i),3)          .AND.     &
+                             BTEST(wall_flags_static_0(k+1,j,i),3) )      .OR.      &
+                     ( .NOT. BTEST(wall_flags_static_0(k+1,j,i),3)        .AND.     &
+                             BTEST(wall_flags_static_0(k,j,i),3) )        .OR.      &        
+                     k == nzt -1 )                                                  &
                 THEN
 !
@@ -769,23 +772,23 @@
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 24 )
                    flag_set = .TRUE.
-                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k-1,j,i),3)    .AND.       &
-                                 BTEST(wall_flags_0(k,j,i),3)      .AND.       &
-                                 BTEST(wall_flags_0(k+1,j,i),3)    .AND.       &
-                                 BTEST(wall_flags_0(k_pp,j,i),3) ) .OR.        &
-                         ( .NOT. BTEST(wall_flags_0(k_pp,j,i),3)   .AND.       &
-                                 BTEST(wall_flags_0(k+1,j,i),3)    .AND.       &
-                                 BTEST(wall_flags_0(k,j,i),3)      .AND.       &
-                                 BTEST(wall_flags_0(k-1,j,i),3) )  .AND.       &
-                           .NOT. flag_set                          .OR.        & 
-                         k == nzt - 2 )                                        &
+                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k-1,j,i),3)    .AND.     &
+                                 BTEST(wall_flags_static_0(k,j,i),3)      .AND.     &
+                                 BTEST(wall_flags_static_0(k+1,j,i),3)    .AND.     &
+                                 BTEST(wall_flags_static_0(k_pp,j,i),3) ) .OR.      &
+                         ( .NOT. BTEST(wall_flags_static_0(k_pp,j,i),3)   .AND.     &
+                                 BTEST(wall_flags_static_0(k+1,j,i),3)    .AND.     &
+                                 BTEST(wall_flags_static_0(k,j,i),3)      .AND.     &
+                                 BTEST(wall_flags_static_0(k-1,j,i),3) )  .AND.     &
+                           .NOT. flag_set                          .OR.             & 
+                         k == nzt - 2 )                                             &
                 THEN                                                           
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 25 )      
                    flag_set = .TRUE.                                           
-                ELSEIF ( BTEST(wall_flags_0(k-1,j,i),3)   .AND.                &
-                         BTEST(wall_flags_0(k,j,i),3)     .AND.                &
-                         BTEST(wall_flags_0(k+1,j,i),3)   .AND.                &
-                         BTEST(wall_flags_0(k_pp,j,i),3)  .AND.                &
-                         .NOT. flag_set )                                      &
-                THEN
+                ELSEIF ( BTEST(wall_flags_static_0(k-1,j,i),3)            .AND.     &
+                         BTEST(wall_flags_static_0(k,j,i),3)              .AND.     &
+                         BTEST(wall_flags_static_0(k+1,j,i),3)            .AND.     &
+                         BTEST(wall_flags_static_0(k_pp,j,i),3)           .AND.     &
+                         .NOT. flag_set )                                           &
+                THEN                                                                
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 26 )
                 ENDIF
@@ -857,33 +860,33 @@
           DO  j = nys, nyn
              DO  k = nzb+1, nzt
-                IF ( .NOT.  BTEST(wall_flags_0(k,j,i),0) )  CYCLE
+                IF ( .NOT.  BTEST(wall_flags_static_0(k,j,i),0) )  CYCLE
 !
 !--             scalar - x-direction
 !--             WS1 (0), WS3 (1), WS5 (2)
-                IF ( ( .NOT. BTEST(wall_flags_0(k,j,i+1),0)                    &
-                 .OR.  .NOT. BTEST(wall_flags_0(k,j,i+2),0)                    &   
-                 .OR.  .NOT. BTEST(wall_flags_0(k,j,i-1),0) )                  &
-                   .OR.  ( non_cyclic_l  .AND.  i == 0  )                      &
-                   .OR.  ( non_cyclic_r  .AND.  i == nx ) )  THEN           
-                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 0 )             
-                ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+3),0)                &
-                    .AND.        BTEST(wall_flags_0(k,j,i+1),0)                &
-                    .AND.        BTEST(wall_flags_0(k,j,i+2),0)                &
-                    .AND.        BTEST(wall_flags_0(k,j,i-1),0)                &
-                         )                       .OR.                          &
-                         ( .NOT. BTEST(wall_flags_0(k,j,i-2),0)                &
-                    .AND.        BTEST(wall_flags_0(k,j,i+1),0)                &
-                    .AND.        BTEST(wall_flags_0(k,j,i+2),0)                &
-                    .AND.        BTEST(wall_flags_0(k,j,i-1),0)                &
-                         )                                                     &
-                                                 .OR.                          &
-                         ( non_cyclic_r  .AND.  i == nx-1 )  .OR.              &
+                IF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i+1),0)      .OR.          &
+                       .NOT. BTEST(wall_flags_static_0(k,j,i+2),0)      .OR.          &   
+                       .NOT. BTEST(wall_flags_static_0(k,j,i-1),0) )    .OR.          &
+                       ( non_cyclic_l  .AND.  i == 0  )                 .OR.          &
+                       ( non_cyclic_r  .AND.  i == nx ) )  THEN           
+                 advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 0 )             
+                ELSEIF ( ( .NOT. BTEST(wall_flags_static_0(k,j,i+3),0)  .AND.         &
+                                 BTEST(wall_flags_static_0(k,j,i+1),0)  .AND.         &
+                                 BTEST(wall_flags_static_0(k,j,i+2),0)  .AND.         &
+                                 BTEST(wall_flags_static_0(k,j,i-1),0)                &
+                         )                       .OR.                                 &
+                         ( .NOT. BTEST(wall_flags_static_0(k,j,i-2),0)  .AND.         &
+                                 BTEST(wall_flags_static_0(k,j,i+1),0)  .AND.         &
+                                 BTEST(wall_flags_static_0(k,j,i+2),0)  .AND.         &
+                                 BTEST(wall_flags_static_0(k,j,i-1),0)                &
+                         )                                                            &
+                                                 .OR.                                 &
+                         ( non_cyclic_r  .AND.  i == nx-1 )  .OR.                     &
                          ( non_cyclic_l  .AND.  i == 1    ) )  THEN           
                    advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 1 )             
-                ELSEIF ( BTEST(wall_flags_0(k,j,i+1),0)                        &
-                   .AND. BTEST(wall_flags_0(k,j,i+2),0)                        &
-                   .AND. BTEST(wall_flags_0(k,j,i+3),0)                        &
-                   .AND. BTEST(wall_flags_0(k,j,i-1),0)                        &
-                   .AND. BTEST(wall_flags_0(k,j,i-2),0) )                      &
+                ELSEIF ( BTEST(wall_flags_static_0(k,j,i+1),0)           .AND.        &
+                         BTEST(wall_flags_static_0(k,j,i+2),0)           .AND.        &
+                         BTEST(wall_flags_static_0(k,j,i+3),0)           .AND.        &
+                         BTEST(wall_flags_static_0(k,j,i-1),0)           .AND.        &
+                         BTEST(wall_flags_static_0(k,j,i-2),0) )                      &
                 THEN                                                           
                    advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 2 )             
